<template>
  <el-table   :highlight-current-row="highlightCurrentRow"  :height="height || '100%'" :row-key="rowKey" :row-class-name="rowClassName"
		@current-change="handleCurrentRow"
    :data="data"
    style="width: 100%">

		<slot ></slot>
		<!-- <slot name="responsive" /> -->
		<el-table-column width="120" v-if="actions.delete || actions.edit || actions.custom"   label="" >
			<template v-slot="{row}">
				<div class="row-actions" v-if="row == selectedRow">
					<slot name="row-actions" :row="row" />
					<el-button v-if="actions.delete" class="boton-tabla" size="small"  type="danger"  @click="onDelete(row)">
						<el-icon ><Delete /></el-icon>
					</el-button>
					<el-button v-if="actions.edit" class="boton-tabla" size="small"  type="primary"  @click="onEdit(row)">
						<el-icon ><Edit /></el-icon>
					</el-button>
				</div>
			</template>
		</el-table-column>
  </el-table>
</template>
<script >

export default {
	props: {
		data: Array,
		selected: [Array, Object],
		rowKey: [String],
		rowClassName: Function,
		height: [String,Number],
		highlightCurrentRow: {
			type: Boolean,
			default: true
		},
		actions: {
			type: Object,
			default() {
				return {
					edit:false,
					delete:false,
					custom: false,
				}
			}
		}
	},
	methods: {
		handleCurrentRow(row) {
			this.$emit('update:selected', row)
			this.selectedRow = row
		},
		onDelete(row){
			this.$emit('delete', row)
		},
		onEdit(row){
			this.$emit('edit', row)
		}
	},
	data(){
		return {
			selectedRow: null,
		}
	}
}
</script>
<style >
.current-row {
	font-weight: bold;
	/* color: red; */
	background-color: blue;
}

.flex-column {
	height: calc(100%);
	overflow: auto;
	display: flex;
	flex-direction: column;
}

.row-actions {
	float:right;
}

.boton-tabla {
	padding: 4px !important;
	margin: 1px !important;
}


</style>